/* Vertical Tiny Scrolling - a smooth scrolling script for horizontal websites
   Modified from the horizontal scrolling code of Marco Rosella
   http://www.centralscrutinizer.it/en/design/js-php/horizontal-tiny-scrolling
				
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA				
*/

window.onload = function() {
	tinyScrolling.init();
}

var tinyScrolling = {
	speed : 10,     // maximum number of pixels to move per time step. 
	timeout : 2,     // time between scroll increments 
	                 // when this value increases, the scrolling speed decreases. 
	maxStep: 1500,	 // set here the "uniform motion" step for long distances
	brakeK: 5,		 // set here the coefficient of slowing down
	hash:null,		
	currentBlock:null,
	requestedY:0,
	init: function() {
		var lnks = document.getElementsByTagName('a');   
		for(var i = 0, lnk; lnk = lnks[i]; i++) {   
			if ((lnk.href && lnk.href.indexOf('#') != -1) &&  ( (lnk.pathname == location.pathname) ||
			   ('/'+lnk.pathname == location.pathname) ) && (lnk.search == location.search)) {
				lnk.onclick = tinyScrolling.initScroll;   		
			}   
		}
	},
	getElementYpos: function(el) {
			var y = 0;
			while(el.offsetParent) {  
				y += el.offsetTop    
				el = el.offsetParent;
			}	return y;
	},		
	getScrollTop: function() {
			if(document.all) return (document.documentElement.scrollTop) ? document.documentElement.scrollTop : document.body.scrollTop;
			else return window.pageYOffset;   
	},	
	getWindowHeight: function() {
			if (window.innerHeight)	return window.innerHeight;
			if(document.documentElement && document.documentElement.clientHeight) return document.documentElement.clientHeight;
	},
	getDocumentHeight: function() {
			if (document.height) return document.height;
			if(document.body.offsetHeight) return document.body.offsetHeight;
	},
	initScroll: function(e) {
			var targ;  
			if (!e) var e = window.event;
			if (e.target) {
				targ = e.target;
			}
			else if (e.srcElement) targ = e.srcElement;   
			tinyScrolling.hash = targ.name.substr(targ.name.indexOf('#')+1,targ.name.length); 
			tinyScrolling.currentBlock = document.getElementById(tinyScrolling.hash);   
			if(!tinyScrolling.currentBlock) return;
			tinyScrolling.requestedY = tinyScrolling.getElementYpos(tinyScrolling.currentBlock); 
			tinyScrolling.scroll();  
			return false;
	},
	scroll: function() {
			var top  = tinyScrolling.getScrollTop();
			if(Math.round((tinyScrolling.requestedY-top)/ tinyScrolling.brakeK) > 0) {				
                var offset = Math.min(Math.abs(Math.round((tinyScrolling.requestedY-top)/ tinyScrolling.brakeK)), tinyScrolling.maxStep);
			} else { 
                var offset = - Math.min(Math.abs(Math.round((tinyScrolling.requestedY-top)/ tinyScrolling.brakeK)), tinyScrolling.maxStep);
			} 
            window.scrollTo(0, top + offset);  
			
            if(Math.abs(top-tinyScrolling.requestedY) <= 1 || tinyScrolling.getScrollTop() == top) {
				window.scrollTo(0, tinyScrolling.requestedY);
				if(!document.all || window.opera) location.hash = tinyScrolling.hash;
				tinyScrolling.hash = null;
		    } else {
				setTimeout(tinyScrolling.scroll, tinyScrolling.timeout);
		    }
	}		
}